/*****************************************************************************/
//
//  superposition.hpp: C++ version of Perl module "Quantum::Superpositions"
//
//   $URL: https://yak.myhome.cx/repos/source/mylib/trunk/cpp/superposition.hpp $
//  $Date: 2007-10-25 01:08:28 +0900 (Thu, 25 Oct 2007) $
//   $Rev: 478 $
//
//      Copyright (c) 2007 Yak!
//
//  This code is distributed under the zlib/libpng License.
//  See http://www.opensource.org/licenses/zlib-license.php
//
/*****************************************************************************/

#ifndef YAK_UTIL_SUPERPOSITION_HPP
#define YAK_UTIL_SUPERPOSITION_HPP

#include <boost/preprocessor/repetition/repeat.hpp>
#include <boost/preprocessor/seq/elem.hpp>
#include <boost/preprocessor/tuple/elem.hpp>

// Sequence of tuples for operators
#define OPERATOR_NUM 6
#define OPERATOR_SEQ ((EqOp, ==, ==)) \
                     ((NeqOp, !=, !=)) \
                     ((TupleLessOp, <, >)) \
                     ((TupleLessEqOp, <=, >=)) \
                     ((TupleGreaterOp, >, <)) \
                     ((TupleGreaterEqOp, >=, <=))

#define OPERATOR_CLASS(i) BOOST_PP_TUPLE_ELEM(3, 0, BOOST_PP_SEQ_ELEM(i, OPERATOR_SEQ))
#define OPERATOR_OP(i) BOOST_PP_TUPLE_ELEM(3, 1, BOOST_PP_SEQ_ELEM(i, OPERATOR_SEQ))
#define OPERATOR_OP_REV(i) BOOST_PP_TUPLE_ELEM(3, 2, BOOST_PP_SEQ_ELEM(i, OPERATOR_SEQ))

namespace yak {
namespace util {
namespace superposition {

enum spos_type {
	any_type,
	all_type
};

} // namespace superposition
} // namespace util
} // namespace yak

#if defined(__VARIADIC_TEMPLATES) || defined(__GXX_EXPERIMENTAL_CXX0X__)

// variadic templates version
#include "superposition_impl_v.hpp"

#else // defined(__VARIADIC_TEMPLATES) || defined(__GXX_EXPERIMENTAL_CXX0X__)

// non-variadic version
#include "superposition_impl_nv.hpp"

#endif // defined(__VARIADIC_TEMPLATES) || defined(__GXX_EXPERIMENTAL_CXX0X__)

namespace yak {
namespace util {

// lift to yak::util namespace

using superposition::any;
using superposition::all;

} // namespace util
} // namesapce yak

#undef OPERATOR_NUM
#undef OPERATOR_SEQ
#undef OPERATOR_CLASS
#undef OPERATOR_OP

#endif // YAK_UTIL_SUPERPOSITION_HPP
